// Copyright (c) 2019-present,  SurfStudio LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

import 'package:surf_network/surf_network.dart';

/// Service that incapsulates performing of the network requests
/// and storage for their responses.
abstract class NetworkCache {
  /// Get data from local storage or
  /// make network request and save response.
  /// Behavior may be customized with CacheStrategy
  Stream<Response> hybridGet(
    String url, {
    Map<String, dynamic> query,
    Map<String, String> headers,
    Duration lifetime,
  });

  void clearCache();
}
